﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.Collections;
using System.Collections.Generic;
namespace HumanResources
{
    public class HumanResources
    {
        #region Declarations
        public DateTime postingDate { get; set; }
        public string jobTitle { get; set; }
        public string requiredQual { get; set; }
        public string preferredQual { get; set; }
        public string responsibilities { get; set; }
        public DateTime startDate { get; set; }
        public string salary { get; set; }
        public string applyInfo { get; set; }
        public bool active { get; set; }
        public Guid guid { get; set; }
        #endregion

        #region Methods
        public void AddJob()
        {
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["mwd"].ConnectionString);
            SqlCommand cmd = new SqlCommand("spHumanResourcesAddJob", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            SqlParameter parameterPostingDate = new SqlParameter("@PostingDate", SqlDbType.DateTime);
            SqlParameter parameterJobTitle = new SqlParameter("@JobTitle", SqlDbType.VarChar, 100);
            SqlParameter parameterReqQual = new SqlParameter("@RequiredQual", SqlDbType.VarChar, 100);
            SqlParameter parameterPrefQual = new SqlParameter("@PreferredQual", SqlDbType.VarChar, 50);
            SqlParameter parameterResponsibilities = new SqlParameter("@Responsibilities", SqlDbType.VarChar, 500);
            SqlParameter parameterStartDate = new SqlParameter("@StartDate", SqlDbType.DateTime);
            SqlParameter parameterSalary = new SqlParameter("@Salary", SqlDbType.VarChar, 50);
            SqlParameter parameterApplyInfo = new SqlParameter("@ApplyInfo", SqlDbType.VarChar, 500);
            SqlParameter parameterActive = new SqlParameter("@Active", SqlDbType.Bit);
            parameterPostingDate.Value = postingDate;
            parameterJobTitle.Value = jobTitle;
            parameterReqQual.Value = requiredQual;
            parameterPrefQual.Value = preferredQual;
            parameterResponsibilities.Value = responsibilities;
            parameterStartDate.Value = startDate;
            parameterSalary.Value = salary;
            parameterApplyInfo.Value = applyInfo;
            parameterActive.Value = active;
            cmd.Parameters.Add(parameterPostingDate);
            cmd.Parameters.Add(parameterJobTitle);
            cmd.Parameters.Add(parameterReqQual);
            cmd.Parameters.Add(parameterPrefQual);
            cmd.Parameters.Add(parameterResponsibilities);
            cmd.Parameters.Add(parameterStartDate);
            cmd.Parameters.Add(parameterSalary);
            cmd.Parameters.Add(parameterApplyInfo);
            cmd.Parameters.Add(parameterActive);
            try
            {
                conn.Open();
                cmd.ExecuteNonQuery();
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
        }
        public static List<HumanResources> ViewAllJobs()
        {
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["mwd"].ConnectionString);
            SqlCommand cmd = new SqlCommand("spHumanResourcesViewAllJobs", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            List<HumanResources> jobs = new List<HumanResources>();
            try
            {
                conn.Open();
                SqlDataReader rdr = cmd.ExecuteReader();
                while (rdr.Read())
                {
                    HumanResources hr = new HumanResources();
                    hr.jobTitle = rdr["JobTitle"].ToString();
                    Guid guid = new Guid(rdr["Guid"].ToString());
                    hr.guid = guid;
                    jobs.Add(hr);
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
            return jobs;
        }
        public static List<HumanResources>ViewJob(Guid guid)
        {
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["mwd"].ConnectionString);
            SqlCommand cmd = new SqlCommand("spHumanResourcesViewJob", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            SqlParameter uniqueid = new SqlParameter("@Guid", SqlDbType.UniqueIdentifier,36);
            uniqueid.Value = guid;
            cmd.Parameters.Add(uniqueid);
            List<HumanResources> viewjob=new List<HumanResources>();
            try
            {
                conn.Open();
                SqlDataReader rdr = cmd.ExecuteReader();
                while (rdr.Read())
                {
                    HumanResources hr = new HumanResources();
                    hr.jobTitle = rdr["JobTitle"].ToString();
                    hr.postingDate = Convert.ToDateTime(rdr["PostingDate"].ToString());
                    hr.startDate = Convert.ToDateTime(rdr["StartDate"].ToString());
                    hr.requiredQual = rdr["RequiredQual"].ToString();
                    hr.preferredQual = rdr["PreferredQual"].ToString();
                    hr.responsibilities = rdr["Responsibilities"].ToString();
                    hr.salary = rdr["Salary"].ToString();
                    hr.applyInfo = rdr["ApplyInfo"].ToString();
                    viewjob.Add(hr);
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
            return viewjob;
        }

        public static List<HumanResources> ViewInactiveJobs()
        {
            SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["mwd"].ConnectionString);
            SqlCommand cmd = new SqlCommand("spHumanResourcesViewInactiveJobs", conn);
            cmd.CommandType = CommandType.StoredProcedure;
            List<HumanResources> jobs = new List<HumanResources>();
            try
            {
                conn.Open();
                SqlDataReader rdr = cmd.ExecuteReader();
                while (rdr.Read())
                {
                    HumanResources hr = new HumanResources();
                    hr.jobTitle = rdr["JobTitle"].ToString();
                    jobs.Add(hr);
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.ToString());
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }
            return jobs;
        }
        #endregion
    }
}
